### Method

# Gio ProxyResolver lookup

since: 2.26

#### Declaration [src]

    gchar**
    g_proxy_resolver_lookup (
      GProxyResolver* resolver,
      const gchar* uri,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Looks into the system proxy configuration to determine what proxy, if any, to use to connect to `uri`. The returned proxy URIs are of the form `<protocol>://[user[:password]@]host[:port]` or `direct://`, where `<protocol>` could be http, rtsp, socks or other proxying protocol.

If you don’t know what network protocol is being used on the socket, you should use `none` as the URI protocol. In this case, the resolver might still return a generic proxy type (such as SOCKS), but would not return protocol-specific proxy types (such as http).

`direct://` is used when no proxy is needed. Direct connection should not be attempted unless it is part of the returned array of proxies.

Available since: 2.26

#### Parameters

`uri`

  Type: `const gchar*`

  A URI representing the destination to connect to.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`cancellable`

  Type: `GCancellable`

  A `GCancellable`, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: An array of `utf8`

A NULL-terminated array of proxy URIs. Must be freed with g_strfreev().

The array is `NULL`-terminated.
The caller of the method takes ownership of the returned data, and is responsible for freeing it.
Each element is a NUL terminated UTF-8 string.